function Log() {}
Log.getUid = function() {
  return (new Date().getTime()) * 1000 + Math.round(Math.random() * 1000)
};
(function() {
  var protocol = "https:";
  var a = protocol + "//pb.sogou.com/",
    b, c, d, e, f, i;
  //设置需要配置的参数，以下划线开始的表示私有的参数，不能被外部设置
  b = {
    "_stayTime": new Date().getTime(), //页面加载初始时间
    "_clUrl": a + "cl.gif", //用户行为日志服务入口
    "_pvUrl": a + "pv.gif" //pv日志服务入口
  };
  for (i in b) {
    Log[i] = b[i]
  }
  //Log.params中的参数可被外部传入的全局变量uigs_para的同名参数覆盖
  Log.params = {
    "uigs_uuid": Log.getUid(), //日志userid
    "uigs_productid": "sogoumaps", //搜狗地图产品的标识
    "uigs_cookie": "YYID,SMAPUVID", //要求每次获取的几个UID
    "uigs_version": "v1.1", //日志系统版本号，跟搜狗日志系统一致
    "app": "iPhoneWeb_Smap" //应用名称
  };
})();
//获取cookie
Log.getCookie = function(a, b) {
  var d, e, f = "",
    i;
  //,g=UserData
  d = document.cookie;
  d = d && d.split("; ") || [];
  for (i = 0; i < d.length; i++) {
    e = d[i].split("=");
    if (e[0] == a) {
      f = e[1];
      break
    }
  }
  // !b&&(f=f||(g&&g.get(a))||"");
  return f
};
Log.getCookieStr = function() {
  var b = "YYID,SMAPUVID",
    c = [],
    d = "",
    i;
  if (b) {
    b = b.split(",");
    for (i = 0; i < b.length; i++) c.push(b[i] + "=" + Log.getCookie(b[i]));
    d = c.join("&")
  }
  return d
};
Log.getHead = function() {
  // 地铁图新增参数hash、originurltype
  var _hash = '';
  var _otype = '';
  if (window.location.href.lastIndexOf('originurltype') > -1) {
    var _index;
    var _i1 = window.location.href.indexOf('#');
    var _i2 = window.location.href.indexOf('?');
    if (_i1 == -1) {
      _index = _i2;
    } else if (_i2 == -1) {
      _index = _i1;
    } else {
      _index = Math.min(_i1, _i2);
    }
    _hash = _index > -1 ? window.location.href.substring(_index + 1) : '';
    // _otype = window.location.href.match(/originurltype=.*?[&]/)[0].split('=')[1].replace('&', '');
    //            CLog.send('originurltype= '+window.location.href.match(/originurltype=.*[&]?/)[0].split('=')[1] + '&hash='+ _hash);
  }

  var a = document,
    b, c = [],
    d = Log.params,
    e, f = {},
    g = a.referrer,
    h = encodeURIComponent,
    i, k;
  //
  Log.getMobileType();
  //先执行callback，更新下参数，如：uigs_para
  (k = Log.callback) && k();
  //b=uigs_para为全局变量，搜狗pv系统专用
  b = window["uigs_para"] || {};
  e = {
    "os": Log.os,
    "osVer": Log.osVer,
    "step": Log.step++,
    "uigs_refer": h(g),
    "uigs_t": Log.getUid(),
    "uigs_cookie": Log.getCookieStr(),
    "hash": _hash
  };
  !a.cookie && (e["nonCookie"] = "1");
  //克隆参数
  for (i in d) f[i] = d[i];
  //合并参数
  for (i in e) f[i] = e[i];
  //处理外部传入的参数
  for (i in b) {
    e[i] || (f[i] = b[i])
  }
  //拼接所有参数
  for (i in f) c.push(h(i) + "=" + h(f[i]));
  return c.join("&");
};
Log.send = function(a) {
  var b = Log._clUrl + "?" + Log.getHead(),
    d = [];
  d.push("uigs_st=" + Log.getStayTime());
  d.push("uigs_cl=" + encodeURIComponent(a));
  b = b + "&" + d.join("&");
  Log.createSender(b);
};
Log.createSender = function(a) {
  var c = Log.senders,
    e;
  c || (c = Log.senders = []);
  e = c[c.length] = new Image();
  e.src = a;
}
Log.getStayTime = function() {
  return parseInt((new Date().getTime() - Log._stayTime) / 1000)
};
//判断设备
Log.getMobileType = function() {
  var t = "unknow",
    ua = window.navigator.userAgent,
    os, osVer, appDownName;
  if (tmpMatch = ua.match(/(iPhone\sOS)\s([\d_]+)/)) {
    os = 'ios';
    osVer = tmpMatch[2].replace(/_/g, '.');
    appDownName = 'iPhone';
  } else if (tmpMatch = ua.match(/(Android)\s+([\d.]+)/)) {
    os = 'and';
    osVer = tmpMatch[2].replace(/_/g, '.');
    appDownName = 'Android';
  } else {
    os = 'other';
    osVer = 'other';
    appDownName = '手机';
  }
  Log.os = os;
  Log.osVer = os;
  Log.appDownName = appDownName;
}